package com.github.fengyuchenglun.example.spring.advanced;

import com.github.fengyuchenglun.example.annotation.KimController;
import com.github.fengyuchenglun.example.common.Query;
import com.github.fengyuchenglun.example.common.User;
import lombok.Data;
import org.springframework.web.bind.annotation.*;

import java.io.Serializable;

/**
 * 用户接口.
 *
 * @author duanledexianxianxian
 * @version 1.0.0
 * @date 2020 /3/25 1:00
 * @index 20
 * @since 1.0.0
 */
@KimController
@RequestMapping("/api/v1/users")
public class UserController {


    /**
     * 查看用户详情
     *
     * @param userId 用户编号
     * @param query  过滤条件
     * @return 用户对象 user
     */
    @GetMapping(value = "/{userId}")
    public User detail(@PathVariable String userId, Query query) {
        User user = new User();
        return user;
    }

    /**
     * 查看用户详情
     *
     * @param query 过滤条件
     * @return 用户对象 user
     */
    @GetMapping(value = "/detail1")
    public User detail1( Query query) {
        User user = new User();
        return user;
    }

    /**
     * 查看用户详情
     *
     * @param query 过滤条件
     * @return 用户对象 user
     */
    @GetMapping(value = "/detail3")
    public User detail3(@RequestParam Query query) {
        User user = new User();
        return user;
    }

    /**
     * 用户表单对象.
     *
     * @author duanledexianxianxian
     */
    @Data
    public static class UserForm implements Serializable {

        private static final long serialVersionUID = 5681371348688016281L;
        /**
         * 用户名
         */
        private String userName;
        /**
         * 地址
         */
        private String address;
        /**
         * 年龄
         */
        private Integer age;
    }

    /**
     * 添加用户
     *
     * @param form 用户表单对象
     * @return integer integer
     */
    @PostMapping
    public Integer add(@RequestBody UserForm form) {
        return null;
    }
}
